;settings.bb
;BlitzBoy
;
;Created by Jan Ebbe on 05.01.2012


Function settings_load()
	settings_default()
	If FileType("blitzboy.ini") = 1 Then settings_parse()
End Function

Function settings_parse()
	ini_stream = ReadFile("blitzboy.ini")
	If ini_stream = 0 Then Return
	
	While Not Eof (ini_stream)
		ini_line$ = ReadLine$ (ini_stream)
		
		If (Not Left(ini_line$,1) = ";") And (Not Left(ini_line$,1) = "[") Then
			chr_pos = Instr (ini_line$, "=") 
			
			If chr_pos > 0 Then
				ini_name$ = Lower$(Trim$(Left(ini_line$,chr_pos-1)))
				ini_value$ = Trim$(Right(ini_line$,Len(ini_line)-chr_pos))
			
				If ini_name$ = "keypad_up" Then
					keypad_up = Int(ini_value$)
				Else If ini_name$ = "keypad_right" Then
					keypad_right = Int(ini_value$)
				Else If ini_name$ = "keypad_down" Then
					keypad_down = Int(ini_value$)
				Else If ini_name$ = "keypad_left" Then
					keypad_left = Int(ini_value$)
				Else If ini_name$ = "keypad_a" Then
					keypad_a = Int(ini_value$)
				Else If ini_name$ = "keypad_b" Then
					keypad_b = Int(ini_value$)
				Else If ini_name$ = "keypad_start" Then
					keypad_start = Int(ini_value$)
				Else If ini_name$ = "keypad_select" Then
					keypad_select = Int(ini_value$)
				Else If ini_name$ = "sound_enabled" Then
					sound_master_enabled = Int(ini_value$)
					If sound_master_enabled = 1 Then
						BASS_Start()
					Else
						BASS_Pause()
					End If
				Else If ini_name$ = "sound_volume" Then
					sound_master_volume = Int(ini_value$)
					BASS_SetVolume(sound_master_volume)
				End If
			End If
		End If
	Wend
	
	CloseFile ini_stream
End Function

Function settings_write()
	ini_stream = WriteFile("blitzboy.ini")
	If ini_stream = 0 Then Return
	
	WriteLine ini_stream, "[controls]"
	WriteLine ini_stream, ";using blitz basic scancodes"
	WriteLine ini_stream, ";http://www.blitzforum.de/help/Scancodes"
	WriteLine ini_stream, "keypad_up = " + Str(keypad_up)
	WriteLine ini_stream, "keypad_right = " + Str(keypad_right)
	WriteLine ini_stream, "keypad_down = " + Str(keypad_down)
	WriteLine ini_stream, "keypad_left = " + Str(keypad_left)
	WriteLine ini_stream, "keypad_a = " + Str(keypad_a)
	WriteLine ini_stream, "keypad_b = " + Str(keypad_b)
	WriteLine ini_stream, "keypad_start = " + Str(keypad_start)
	WriteLine ini_stream, "keypad_select = " + Str(keypad_select)
	WriteLine ini_stream, "[sound]"
	WriteLine ini_stream, "sound_enabled = " + Str(sound_master_enabled)
	WriteLine ini_stream, "sound_volume = " + Str(sound_master_volume)
	
	CloseFile ini_stream
End Function

Function settings_default()
	keypad_up = 200
	keypad_right = 205
	keypad_down = 208
	keypad_left = 203
	keypad_a = 44
	keypad_b = 45
	keypad_select = 57
	keypad_start = 28
	
	sound_master_enabled = 1
	BASS_Start()
	sound_master_volume = 5
	BASS_SetVolume(sound_master_volume)
End Function