;sound.bb
;BlitzBoy
;
;Created by Jan Ebbe on 15.08.2012


Include "bass.bb"

Const sound_res = 44100

Const sound_m1_buffer_size = 88200 ;44100*4*(dur=500)/1000
Const sound_m2_buffer_size = 88200 ;44100*4*(dur=500)/1000
Const sound_m3_buffer_size = 176400 ;44100*4*(dur=1000)/1000
Const sound_m4_buffer_size = 88200 ;44100*4*(dur=500)/1000
Const volume = 32767

Global sound_master_enabled
Global sound_master_volume

Global sound_enabled

Global sound_m1_playing
Global sound_m1_bank
Global sound_m1_sample
Global sound_m1_channel
Global sound_m1_frequency_data_counter
Global sound_m1_volume_counter
Global sound_m1_sweep_time_counter
Global sound_m1_envelope_time_counter
Global sound_m1_length_counter
Global sound_m1_sweep_time
Global sound_m1_sweep_direction
Global sound_m1_sweep_shifts
Global sound_m1_envelope_initial_volume
Global sound_m1_envelope_direction
Global sound_m1_envelope_time
Global sound_m1_wave_duty
Global sound_m1_frequency_data
Global sound_m1_consecutive
Global sound_m1_length
Global sound_m1_so1_output
Global sound_m1_so2_output

Global sound_m2_playing
Global sound_m2_bank
Global sound_m2_sample
Global sound_m2_channel
Global sound_m2_frequency_data_counter
Global sound_m2_volume_counter
Global sound_m2_envelope_time_counter
Global sound_m2_length_counter
Global sound_m2_envelope_initial_volume
Global sound_m2_envelope_direction
Global sound_m2_envelope_time
Global sound_m2_wave_duty
Global sound_m2_frequency_data
Global sound_m2_consecutive
Global sound_m2_length
Global sound_m2_so1_output
Global sound_m2_so2_output

Global sound_m3_playing
Global sound_m3_bank
Global sound_m3_sample
Global sound_m3_channel
Global sound_m3_output
Global sound_m3_length
Global sound_m3_length_counter
Global sound_m3_volume
Global sound_m3_frequency_data
Global sound_m3_consecutive
Global sound_m3_so1_output
Global sound_m3_so2_output

Global sound_m4_playing
Global sound_m4_bank
Global sound_m4_sample
Global sound_m4_channel
Global sound_m4_length
Global sound_m4_length_counter
Global sound_m4_envelope_initial_volume
Global sound_m4_envelope_direction
Global sound_m4_envelope_time
Global sound_m4_envelope_time_counter
Global sound_m4_consecutive
Global sound_m4_frequency_ratio
Global sound_m4_polynomial_counter_step
Global sound_m4_shift_clock_frequency
Global sound_m4_shift_counter
Global sound_m4_so1_output
Global sound_m4_so2_output

Dim sound_waveform(31)


Function sound_init()
	BASS_Init(-1,sound_res,0,QueryObject(gui_window,1),BASS_NULL)
	BASS_SetConfig(BASS_CONFIG_MAXVOL,15)
	
	sound_m1_bank = CreateBank(sound_m1_buffer_size)
	sound_m1_sample = BASS_SampleCreate((sound_m1_buffer_size Shr 2),sound_res,2,1,BASS_SAMPLE_OVER_POS Or BASS_SAMPLE_LOOP)
	sound_m1_channel = BASS_SampleGetChannel(BASS_SampleCreateDone(),0)
	BASS_RtlMoveMemory2(sound_m1_sample,sound_m1_bank,(sound_m1_buffer_size Shr 2))
	
	sound_m2_bank = CreateBank(sound_m2_buffer_size)
	sound_m2_sample = BASS_SampleCreate((sound_m2_buffer_size Shr 2),sound_res,2,1,BASS_SAMPLE_OVER_POS Or BASS_SAMPLE_LOOP)
	sound_m2_channel = BASS_SampleGetChannel(BASS_SampleCreateDone(),0)
	BASS_RtlMoveMemory2(sound_m2_sample,sound_m2_bank,(sound_m2_buffer_size Shr 2))
	
	sound_m3_bank = CreateBank(sound_m3_buffer_size)
	sound_m3_sample = BASS_SampleCreate((sound_m3_buffer_size Shr 2),sound_res,2,1,BASS_SAMPLE_OVER_POS Or BASS_SAMPLE_LOOP)
	sound_m3_channel = BASS_SampleGetChannel(BASS_SampleCreateDone(),0)
	BASS_RtlMoveMemory2(sound_m3_sample,sound_m3_bank,(sound_m3_buffer_size Shr 2))
	
	sound_m4_bank = CreateBank(sound_m4_buffer_size)
	sound_m4_sample = BASS_SampleCreate((sound_m4_buffer_size Shr 2),sound_res,2,1,BASS_SAMPLE_OVER_POS Or BASS_SAMPLE_LOOP)
	sound_m4_channel = BASS_SampleGetChannel(BASS_SampleCreateDone(),0)
	BASS_RtlMoveMemory2(sound_m4_sample,sound_m4_bank,(sound_m4_buffer_size Shr 2))
End Function

Function sound_stop()
	BASS_ChannelStop(sound_m1_channel)
	BASS_ChannelStop(sound_m2_channel)
	BASS_ChannelStop(sound_m3_channel)
	BASS_ChannelStop(sound_m4_channel)
	
	BASS_Stop()
	BASS_Free()
End Function

Function sound_reset()
	sound_enabled = 0

	sound_m1_playing = 0
	sound_m1_frequency_data_counter = 0
	sound_m1_volume_counter = 0
	sound_m1_sweep_time_counter = 0
	sound_m1_length_counter = 0
	sound_m1_envelope_time_counter = 0
	sound_m1_sweep_time = 0
	sound_m1_sweep_direction = 0
	sound_m1_sweep_shifts = 0
	sound_m1_envelope_initial_volume = 0
	sound_m1_envelope_direction = 0
	sound_m1_envelope_time = 0
	sound_m1_wave_duty = 0
	sound_m1_frequency_data = 0
	sound_m1_consecutive = 0
	sound_m1_length = 0
	sound_m1_so1_output = 0
	sound_m1_so2_output = 0
	
	sound_m2_playing = 0
	sound_m2_volume_counter = 0
	sound_m2_envelope_time_counter = 0
	sound_m2_length_counter = 0
	sound_m2_envelope_initial_volume = 0
	sound_m2_envelope_direction = 0
	sound_m2_envelope_time = 0
	sound_m2_wave_duty = 0
	sound_m2_frequency_data = 0
	sound_m2_consecutive = 0
	sound_m2_length = 0
	sound_m2_so1_output = 0
	sound_m2_so2_output = 0
	
	sound_m3_playing = 0
	sound_m3_output = 0
	sound_m3_length = 0
	sound_m3_length_counter = 0
	sound_m3_volume = 0
	sound_m3_frequency_data = 0
	sound_m3_consecutive = 0
	sound_m3_so1_output = 0
	sound_m3_so2_output = 0
	
	sound_m4_length = 0
	sound_m4_length_counter = 0
	sound_m4_envelope_initial_volume = 0
	sound_m4_envelope_direction = 0
	sound_m4_envelope_time = 0
	sound_m4_envelope_time_counter = 0
	sound_m4_consecutive = 0
	sound_m4_frequency_ratio = 0
	sound_m4_polynomial_counter_step = 0
	sound_m4_shift_clock_frequency = 0
	sound_m4_so1_output = 0
	sound_m4_so2_output = 0
	
	Dim sound_waveform(31)
End Function

Function sound_step()
	If sound_enabled = 1 Then
	
		;channel 1
		If sound_m1_playing = 1 And (sound_m1_so1_output + sound_m1_so2_output) > 0 Then
			
			;envelope
			sound_m1_envelope_time_counter = sound_m1_envelope_time_counter + cpu_m
			If sound_m1_envelope_time_counter >= sound_m1_envelope_time And sound_m1_envelope_time > 0 Then
				sound_m1_envelope_time_counter = sound_m1_envelope_time_counter - sound_m1_envelope_time
				
				If sound_m1_envelope_direction = 1 Then
					If sound_m1_volume_counter < 15 Then sound_m1_volume_counter = sound_m1_volume_counter + 1
				Else
					If sound_m1_volume_counter > 0 Then sound_m1_volume_counter = sound_m1_volume_counter - 1
				End If
				
				BASS_ChannelSetAttributes (sound_m1_channel, -1, sound_m1_volume_counter, 0)
			End If
		
			;length
			sound_m1_length_counter = sound_m1_length_counter + cpu_m
			If sound_m1_length_counter >= sound_m1_length And sound_m1_consecutive = 1 Then
				BASS_ChannelPause(sound_m1_channel)
				sound_m1_playing = 0
			End If
			
			;sweep
			sound_m1_sweep_time_counter = sound_m1_sweep_time_counter + cpu_m
			If sound_m1_sweep_time_counter >= sound_m1_sweep_time Then
				sound_m1_sweep_time_counter = sound_m1_sweep_time_counter - sound_m1_sweep_time
				
				If sound_m1_sweep_time > 0 Then
					If sound_m1_sweep_direction = 1 Then
						new_frequency_data = sound_m1_frequency_data_counter - (sound_m1_frequency_data_counter Shr sound_m1_sweep_shifts)
					Else
						new_frequency_data = sound_m1_frequency_data_counter + (sound_m1_frequency_data_counter Shr sound_m1_sweep_shifts)
					End If
			
					If new_frequency_data > $7FF Then
						BASS_ChannelPause(sound_m1_channel)
						sound_m1_playing = 0
					Else If new_frequency_data > 0 And sound_m1_frequency_data_counter <> new_frequency_data Then
						sound_m1_frequency_data_counter = new_frequency_data
						sound_m1_generate()
					End If
				End If
				
				If sound_m1_playing = 1 Then BASS_ChannelPlay(sound_m1_channel,BASS_FALSE)
				
			End If
			
		Else
			BASS_ChannelPause(sound_m1_channel)
		End If
		
		;channel 2
		If sound_m2_playing = 1 And (sound_m2_so1_output + sound_m2_so2_output) > 0 Then
			
			;envelope
			sound_m2_envelope_time_counter = sound_m2_envelope_time_counter + cpu_m
			If sound_m2_envelope_time_counter >= sound_m2_envelope_time And sound_m2_envelope_time > 0 Then
				sound_m2_envelope_time_counter = sound_m2_envelope_time_counter - sound_m2_envelope_time
				
				If sound_m2_envelope_direction = 1 Then
					If sound_m2_volume_counter < 15 Then sound_m2_volume_counter = sound_m2_volume_counter + 1
				Else
					If sound_m2_volume_counter > 0 Then sound_m2_volume_counter = sound_m2_volume_counter - 1
				End If

				BASS_ChannelSetAttributes (sound_m2_channel, -1, sound_m2_volume_counter, 0)
			End If
			
			;length
			sound_m2_length_counter = sound_m2_length_counter + cpu_m
			If sound_m2_length_counter >= sound_m2_length Then
				sound_m2_length_counter = sound_m2_length_counter - sound_m2_length
				
				If sound_m2_consecutive = 1 Then
					BASS_ChannelPause(sound_m2_channel)
					sound_m2_playing = 0
				Else
					BASS_ChannelPlay(sound_m2_channel,BASS_FALSE)
				End If
			End If
			
		Else
			BASS_ChannelPause(sound_m2_channel)
		End If
		
		;channel 3
		If sound_m3_playing = 1 And (sound_m3_so1_output + sound_m3_so2_output) > 0 And sound_m3_output = 1 Then
			
			;length
			sound_m3_length_counter = sound_m3_length_counter + cpu_m
			If sound_m3_length_counter >= sound_m3_length Then
				sound_m3_length_counter = sound_m3_length_counter - sound_m3_length
				
				If sound_m3_consecutive = 1 Then
					BASS_ChannelPause(sound_m3_channel)
					sound_m3_playing = 0
				Else
					sound_m3_generate()
					BASS_ChannelSetAttributes (sound_m3_channel, -1, sound_m3_volume, 0)
					BASS_ChannelPlay(sound_m3_channel,BASS_FALSE)
				End If
			End If
			
		Else
			BASS_ChannelPause(sound_m3_channel)
		End If
		
		;channel 4
		If sound_m4_playing = 1 And (sound_m4_so1_output + sound_m4_so2_output) > 0 Then
			
			;envelope
			sound_m4_envelope_time_counter = sound_m4_envelope_time_counter + cpu_m
			If sound_m4_envelope_time_counter >= sound_m4_envelope_time And sound_m4_envelope_time > 0 Then
				sound_m4_envelope_time_counter = sound_m4_envelope_time_counter - sound_m4_envelope_time
				
				If sound_m4_envelope_direction = 1 Then
					If sound_m4_volume_counter < 15 Then sound_m4_volume_counter = sound_m4_volume_counter + 1
				Else
					If sound_m4_volume_counter > 0 Then sound_m4_volume_counter = sound_m4_volume_counter - 1
				End If
				
				BASS_ChannelSetAttributes (sound_m4_channel, -1, sound_m4_volume_counter, 0)
			End If
			
			;length
			sound_m4_length_counter = sound_m4_length_counter + cpu_m
			If sound_m4_length_counter >= sound_m4_length Then
				sound_m4_length_counter = sound_m4_length_counter - sound_m4_length
				
				If sound_m4_consecutive = 1 Then
					BASS_ChannelPause(sound_m4_channel)
					sound_m4_playing = 0
				Else
					BASS_ChannelPlay(sound_m4_channel,BASS_FALSE)
				End If
			End If
			
		Else
			BASS_ChannelPause(sound_m4_channel)
		EndIf
		
	End If
End Function

Function sound_m1_start()
	BASS_ChannelPause(sound_m1_channel)

	If sound_enabled = 1 Then
		sound_m1_playing = 1
		sound_m1_frequency_data_counter = sound_m1_frequency_data
		sound_m1_volume_counter = sound_m1_envelope_initial_volume
		sound_m1_sweep_time_counter = 0
		sound_m1_envelope_time_counter = 0
		sound_m1_length_counter = 0
	
		sound_m1_generate()
		BASS_ChannelSetAttributes (sound_m1_channel, -1, sound_m1_volume_counter, 0)
		BASS_ChannelPlay(sound_m1_channel,BASS_FALSE)
	End If
End Function

Function sound_m2_start()
	BASS_ChannelPause(sound_m2_channel)

	If sound_enabled = 1 Then
		sound_m2_playing = 1
		sound_m2_volume_counter = sound_m2_envelope_initial_volume
		sound_m2_envelope_time_counter = 0
		sound_m2_length_counter = 0
	
		sound_m2_generate()
		BASS_ChannelSetAttributes (sound_m2_channel, -1, sound_m2_volume_counter, 0)
		BASS_ChannelPlay(sound_m2_channel,BASS_FALSE)
	End If
End Function

Function sound_m3_start()
	BASS_ChannelPause(sound_m3_channel)

	If sound_enabled = 1 Then
		sound_m3_playing = 1
		sound_m3_length_counter = 0
	
		sound_m3_generate()
		BASS_ChannelSetAttributes (sound_m3_channel, -1, sound_m3_volume, 0)
		BASS_ChannelPlay(sound_m3_channel,BASS_FALSE)
	End If
End Function

Function sound_m4_start()
	BASS_ChannelPause(sound_m4_channel)

	If sound_enabled = 1 Then
		sound_m4_playing = 1
		sound_m4_volume_counter = sound_m4_envelope_initial_volume
		sound_m4_envelope_time_counter = 0
		sound_m4_length_counter = 0
	
		sound_m4_generate()
		BASS_ChannelSetAttributes (sound_m4_channel, -1, sound_m4_volume_counter, 0)
		BASS_ChannelPlay(sound_m4_channel,BASS_FALSE)
	End If
End Function

Function sound_m1_generate()
	volume_so1 = volume * sound_m1_so1_output
	volume_so2 = volume * sound_m1_so2_output
	
	frequency = 131072/(2048-sound_m1_frequency_data_counter)
	eight_periode_size = (((sound_m1_buffer_size / 4) * 2) / frequency) / 8

	Select sound_m1_wave_duty
		Case $00
			fist_half_size = eight_periode_size
		Case $01
			fist_half_size = eight_periode_size * 2
		Case $02
			fist_half_size = eight_periode_size * 4
		Case $03
			fist_half_size = eight_periode_size * 6
	End Select

	m = 0
	For n=0 To (sound_m1_buffer_size Shr 2)-1
		If m < fist_half_size Then
			PokeShort sound_m1_bank, (n Shl 2), volume_so1
			PokeShort sound_m1_bank, 2+(n Shl 2), volume_so2
			m = m + 1
		Else If m > (eight_periode_size Shl 3) Then
			m = 0
		Else
			PokeShort sound_m1_bank, (n Shl 2), 0
			PokeShort sound_m1_bank, 2+(n Shl 2), 0
			m = m + 1
		End If
	Next
	
	BASS_RtlMoveMemory2(sound_m1_sample,sound_m1_bank,(sound_m1_buffer_size Shr 2))
End Function

Function sound_m2_generate()
	volume_so1 = volume * sound_m2_so1_output
	volume_so2 = volume * sound_m2_so2_output
	
	frequency = 131072/(2048-sound_m2_frequency_data)
	eight_periode_size = (((sound_m2_buffer_size / 4) * 2) / frequency) / 8

	Select sound_m2_wave_duty
		Case $00
			fist_half_size = eight_periode_size
		Case $01
			fist_half_size = eight_periode_size * 2
		Case $02
			fist_half_size = eight_periode_size * 4
		Case $03
			fist_half_size = eight_periode_size * 6
	End Select

	m = 0
	For n=0 To (sound_m2_buffer_size Shr 2)-1
		If m < fist_half_size Then
			PokeShort sound_m2_bank, (n Shl 2), volume_so1
			PokeShort sound_m2_bank, 2+(n Shl 2), volume_so2
			m = m + 1
		Else If m > (eight_periode_size Shl 3) Then
			m = 0
		Else
			PokeShort sound_m2_bank, (n Shl 2), 0
			PokeShort sound_m2_bank, 2+(n Shl 2), 0
			m = m + 1
		End If
	Next
	
	BASS_RtlMoveMemory2(sound_m2_sample,sound_m2_bank,(sound_m2_buffer_size Shr 2))
End Function

Function sound_m3_generate()
	frequency = 65536/(2048-sound_m3_frequency_data)
	waveform_size = (((sound_m3_buffer_size / 4) / frequency) / 32) + 1
	
	m = 0
	Repeat
		For i = 0 To 31
			For j = 1 To waveform_size
				If m = (sound_m3_buffer_size Shr 2) Then
					BASS_RtlMoveMemory2(sound_m3_sample,sound_m3_bank,(sound_m3_buffer_size Shr 2))
					Return
				End If
				
				PokeShort sound_m3_bank, (m Shl 2), sound_waveform(i) * sound_m3_so1_output
				PokeShort sound_m3_bank, 2+(m Shl 2), sound_waveform(i) * sound_m3_so2_output
				
				m = m + 1
			Next
		Next
	Forever
End Function

Function sound_m4_generate()
	If sound_m4_frequency_ratio = 0 Then
		frequency = 524288 * 2 / (2^(sound_m4_shift_clock_frequency+1))
	Else
		frequency = 524288 / sound_m4_frequency_ratio / (2^(sound_m4_shift_clock_frequency+1))
	End If
	
	periode_size = ((sound_m4_buffer_size / 4) * 2) / frequency	
	
	If sound_m4_polynomial_counter_step = 1 Then
		shift_register = $40
	Else
		shift_register = $4000
	End If
	
	m = 0
	For n=0 To (sound_m4_buffer_size Shr 2)-1
		m = m + 1
		
		If m > periode_size Then
			m = 0
			
			volume_so1 = 0
			volume_so2 = 0
			
			If sound_m4_polynomial_counter_step = 1 Then 
				carry = shift_register And $01
				shift_register = shift_register Shr 1
				
				If carry = 1 Then
					volume_so1 = volume * sound_m4_so1_output
					volume_so2 = volume * sound_m4_so2_output
					shift_register = shift_register Xor $60
				End If
			Else
				carry = shift_register And $01
				shift_register = shift_register Shr 1
				
				If carry = 1 Then
					volume_so1 = volume * sound_m4_so1_output
					volume_so2 = volume * sound_m4_so2_output
					shift_register = shift_register Xor $6000
				End If
			End If
		End If
		
		PokeShort sound_m4_bank, (n Shl 2), volume_so1
		PokeShort sound_m4_bank, 2+(n Shl 2), volume_so2
	Next
	
	BASS_RtlMoveMemory2(sound_m4_sample,sound_m4_bank,(sound_m4_buffer_size Shr 2))
End Function

Function sound_update_waveform(adr, val)
	num = (adr - $FF30) Shl 1
	
	sound_waveform(num+1) = (val And $0F) * (volume Shr 4)
	sound_waveform(num) = ((val Shr 4) And $0F) * (volume Shr 4)
End Function